﻿Imports System.Collections.Specialized
Imports System.IO
Imports System.Net

Public Class PasteBin

    Public Event Done(ByVal Result As String)

    Private Url As String = "https://pastebin.com/api/api_post.php"

    Private WithEvents Loader As New WebClient
    Private DevKey As String

    Public HighLights As New List(Of SimpleItem)
    Public Expirations As New List(Of SimpleItem)
    Public Visibility As New List(Of SimpleItem) From {
        New SimpleItem("Public", "0"),
        New SimpleItem("Unlisted", "1"),
        New SimpleItem("Private", "2")
    }

    Public Sub New(ByVal DeveloperKey As String)
        DevKey = DeveloperKey
        Dim vars() As String = File.ReadAllLines("highlights.cfg")
        For Each var In vars
            Dim va() As String = var.Split("="c)
            HighLights.Add(New SimpleItem(va(1), va(0)))
        Next
        vars = File.ReadAllLines("expiration.cfg")
        For Each var In vars
            Dim va() As String = var.Split("="c)
            Expirations.Add(New SimpleItem(va(1), va(0)))
        Next
    End Sub

    Public Sub UploadPaste(ByVal pasteName As String, ByVal paste As String, ByVal expiration As String, ByVal vivibility As String, Optional ByVal syntaxHighlight As String = Nothing)
        If Not Loader.IsBusy Then
            Dim POST As New NameValueCollection
            POST.Add("api_option", "paste")
            POST.Add("api_dev_key", DevKey)
            POST.Add("api_paste_name", pasteName)
            POST.Add("api_paste_code", paste)
            POST.Add("api_paste_expire_date", expiration)
            POST.Add("api_paste_private", vivibility)
            If syntaxHighlight <> Nothing Then
                POST.Add("api_paste_format", syntaxHighlight)
            End If
            Loader.UploadValuesAsync(New Uri(Url), POST)
        Else
            MessageBox.Show("I'm busy!")
        End If
    End Sub

    Private Sub Loader_UploadValuesCompleted(ByVal sender As Object, ByVal e As System.Net.UploadValuesCompletedEventArgs) Handles Loader.UploadValuesCompleted
        RaiseEvent Done(System.Text.Encoding.UTF8.GetString(e.Result))
    End Sub

End Class